#include<iostream>
#include<string>
using namespace std;

int main(){
    int N;
    cin >> N;
    int N_O,N_A,N_B,N_AB;
    cin >> N_O >> N_A >> N_B >> N_AB;
    
    string grupa;
    int n;
    int n_O,n_A,n_B,n_AB;
    n_O=0;
    n_A=0;
    n_B=0;
    n_AB=0;
    string grupe[N];
    int brojevi[N];
    for (int i=0;i<N;i++){
        cin >> grupa >> n;
        grupe[i]=grupa;
        brojevi[i]=n;
        if (grupa == "O"){
            n_O=n_O+n;
            
        }
        if (grupa == "A"){
            n_A=n_A+n;            
        }
        if (grupa == "B"){
            n_B=n_B+n;
        }
        if (grupa == "AB"){
            n_AB=n_AB+n;
        }
    }
    int x=1;
    int n_O_O,n_A_O,n_A_A,n_B_O,n_B_B,n_AB_O,n_AB_A,n_AB_B,n_AB_AB;
    if (n_O>N_O) {cout << "nemoguce";x=0;}
    else{
        n_O_O=n_O;
        N_O=N_O-n_O;

        if (n_A>N_O+N_A) {cout << "nemoguce";x=0;}
        else {
            if (n_A>N_A){
                n_A_A=N_A;
                n_A_O=n_A-N_A;
                N_O=N_O-n_A_O;
                N_A=0;
            }
            else{
                n_A_A=n_A;
                n_A_O=0;
                N_A=N_A-n_A;
            }
            if (n_B>N_O+N_B) {cout << "nemoguce";x=0;}
            else{
                if (n_B>N_B){
                    n_B_B=N_B;
                    n_B_O=n_B-N_B;
                    N_O=N_O-n_B_O;
                    N_B=0;
                }
                else{
                    n_B_B=n_B;
                    n_B_O=0;
                    N_B=N_B-n_B;
                }

                if (n_AB>N_O+N_A+N_B+N_AB) {cout << "nemoguce";x=0;}
                else{
                    n_AB_O=N_O;
                    n_AB_A=N_A;
                    n_AB_B=N_B;
                    n_AB_AB=N_AB;
                }

            }
        }
    }



    if (x==1){
        cout << "moguce" << "\n";
        for (int i=0;i<N;i++){
        
        
        if (grupe[i] == "O"){
            cout << brojevi[i] << " 0" << " 0" << " 0" << "\n";
            
        }
        if (grupe[i] == "A"){
            if (n_A_A>brojevi[i]){
                cout << "0 " << brojevi[i] << " " << "0" << " " << "0" << "\n";
                n_A_A=n_A_A-brojevi[i];
            }  
            else{
                if (n_A_A>0) {
                    cout << brojevi[i]-n_A_A << " " << n_A_A << " 0" << " 0" << "\n";
                    n_A_O=n_A_O+n_A_A-brojevi[i];
                    n_A_A=0;

                }
                else{
                    cout << brojevi[i] << " 0" << " 0" << " 0" << "\n";
                    n_A_O=n_A_O-brojevi[i];
                }
            }          
        }
        if (grupe[i] == "B"){
            if (n_B_B>brojevi[i]){
                cout << "0 " << "0 " << brojevi[i] << " 0" << "\n";
                n_B_B=n_B_B-brojevi[i];
            }
            else{
                if (n_B_B>0) {
                    cout << brojevi[i]-n_B_B << " 0 " << n_B_B << " 0" << "\n";
                    n_B_O=n_B_O+n_B_B-brojevi[i];
                    n_B_B=0;

                }
                else{
                    cout << brojevi[i] << " 0" << " 0" << " 0" << "\n";
                    n_B_O=n_B_O-brojevi[i];
                }
            }  
        }

        if (grupe[i] == "AB"){
            if (n_AB_AB>brojevi[i]){
                cout << "0 " << "0 " << "0 " << brojevi[i] << "\n";
                n_AB_AB=n_AB_AB-brojevi[i];
            }
            else{
                if (n_AB_AB+n_AB_A>brojevi[i]){
                    cout << "0 " << brojevi[i]-n_AB_AB << " 0 " << n_AB_AB << "\n";
                    n_AB_A=n_AB_A+n_AB_AB-brojevi[i];
                }
                else{
                    if (n_AB_AB+n_AB_B>brojevi[i]){
                        cout << "0 0 " << brojevi[i]-n_AB_AB << " " << n_AB_AB << "\n";
                        n_AB_B=n_AB_B+n_AB_AB-brojevi[i]; 
                    }
                    else {
                        if (n_AB_AB+n_AB_A+n_AB_B>brojevi[i]){
                            cout << "0 " << n_AB_A << " " << brojevi[i]-n_AB_AB-n_AB_A << " " << n_AB_AB << "\n";
                            n_AB_B=n_AB_B+n_AB_A+n_AB_AB-brojevi[i];
                            n_AB_A=0;
                            n_AB_AB=0;
                        }
                        else{
                            cout << brojevi[i]-n_AB_A-n_AB_B-n_AB_AB << " " << n_AB_A << " " << n_AB_B << " " << n_AB_AB << "\n";
                            n_AB_O=n_AB_O+n_AB_A+n_AB_B+n_AB_AB-brojevi[i];
                        }
                    }
                }
            }
        }
    }
    }



    return 0;
}